package org.nl.acs.device.service;

import com.alibaba.fastjson.JSONObject;
import org.nl.acs.device.domain.DeviceExtra;
import org.nl.acs.device.service.dto.DeviceExtraDto;
import org.nl.acs.device.service.dto.DeviceExtraQueryParam;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.common.base.PageInfo;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface DeviceExtraService extends CommonService<DeviceExtra>  {

    static final String CACHE_KEY = "deviceExtra";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<DeviceExtraDto>
    */
    PageInfo<DeviceExtraDto> queryAll(DeviceExtraQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<DeviceExtraDto>
    */
    List<DeviceExtraDto> queryAll(DeviceExtraQueryParam query);

    DeviceExtra getById(String id);
    DeviceExtraDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(DeviceExtraDto resources);
    int updateById(DeviceExtraDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<DeviceExtraDto> all, HttpServletResponse response) throws IOException;

    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<DeviceExtraDto>
     */
    List<DeviceExtraDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param id ID
     * @return DeviceExtra
     */
//    DeviceExtraDto findById(String id);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return DeviceExtra
     */
//    DeviceExtraDto findByCode(String code);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(DeviceExtraDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(DeviceExtraDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 通过设备ID进行删除
     *
     * @param deviceIds /
     */
    void deleteAllByDeviceIds(String[] deviceIds);

    /**
     * 通过设备驱动配置生成扩展属性
     *
     * @param json
     * @param filed_type:扩展字段类型,01、表单,02:DB读,03:DB写
     */
    void createByDeviceConfig(JSONObject json, String filed_type);
}
